﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

[System.Serializable]
public class Type5mManagerConfig : MonoBehaviour
{
    [TooltipAttribute("アームパワーL(%, 未確率時)")]
    public float[] armLPowerConfig = new float[3];
    [TooltipAttribute("アームパワーL(%, 確率時)")]
    public float[] armLPowerConfigSuccess = new float[3];
    [TooltipAttribute("アームパワーR(%, 未確率時)")]
    public float[] armRPowerConfig = new float[3];
    [TooltipAttribute("アームパワーR(%, 確率時)")]
    public float[] armRPowerConfigSuccess = new float[3];
    [TooltipAttribute("アーム開度")]
    public float armApertures = 80f;
    [TooltipAttribute("アームサイズ 0:なし, 1:S, 2:M, 3:L")]
    public int[] armSize = new int[2];
    [TooltipAttribute("Zメカ角度 (-90～90)")]
    public float armUnitAngle = 0f;
    [TooltipAttribute("X,Y移動制限(%)")]
    public float[] boxRestrictions = new float[2];
    [TooltipAttribute("下降制限(%)")]
    public float downRestriction = 100f;
    [TooltipAttribute("3ボタンの使用可否")]
    public bool downStop = true;
    [TooltipAttribute("押し込み時間調整(ミリ秒)")]
    public int pushTime = 300;
    [TooltipAttribute("開始位置座標定義 (x,y,z)")]
    public Vector3 startPoint = new Vector3();
    [TooltipAttribute("獲得口座標定義(prizezoneType=9の場合使用 x,z)")]
    public Vector3 homePoint = new Vector3();
    [TooltipAttribute("1:左手前，2：左奥，3：右手前，4：右奥，5：左，6：手前，7：右，8：奥，9：特定座標")]
    public int prizezoneType = 9;
    [TooltipAttribute("離し位置でアームを開く")]
    public bool doRelease = true;
    [TooltipAttribute("時間内取り放題モード設定")]
    public bool alytMode = false;
    [TooltipAttribute("残り時間の設定(時間内取り放題モード)")]
    public int limitTimeSet = 60;

    // 以下追加
    [Range(1, 5), TooltipAttribute("アーム移動速度(1～5)")]
    public int armMoveSpeed = 3;
    [Range(1, 5), TooltipAttribute("アーム降下速度(1～5)")]
    public int armDownSpeed = 3;
    [Range(1, 5), TooltipAttribute("アーム上昇速度(1～5)")]
    public int armUpSpeed = 5;
    [TooltipAttribute("アーム閉じにモーターを使用する")]
    public bool useMotor = true;
}
