﻿using System;
using System.Collections;
using System.Threading.Tasks;
using UnityEngine;
using UnityEngine.UI;

/// <summary>
/// TYPE-5 mod V3コンポーネント正式対応版
/// </summary>
public class Type5mManagerV3 : CraneManagerV3
{
    public Type5mManagerConfig config;
    public bool player2 = false;
    [SerializeField] TextMesh credit3d;
    [SerializeField] TextMesh[] preset = new TextMesh[4];
    [HideInInspector] public Animator[] animator = new Animator[3];
    [HideInInspector] public Type5NetworkV3 net;
    [HideInInspector] public int soundType = 0; //SEの切り替え 0,1: CATCHER 8,9 2: CATCHER 7 Selecterで指定すること
    [HideInInspector] public bool buttonPushed = false; //trueならボタンをクリックしているかキーボードを押下している
    [HideInInspector] public float armLPower;
    [HideInInspector] public float armRPower;
    private int alytPlayCount = 0;
    private TwinArmController armController;
    private ArmControllerSupportV3 support;
    private ArmUnitLifterV3 lifter;
    private ArmNailV3[] nail = new ArmNailV3[2];

    // 定数
    private const float OUTER_LIMIT = 0.64f;
    private const float INNER_LIMIT = 0.19f;
    private const float BACK_LIMIT = 0.235f;
    private const float FRONT_LIMIT = -0.235f;

    private const float UP_LIMIT = -0.206f;
    private const float DOWN_LIMIT = -0.81f;

    void Start()
    {
        Transform temp = transform.Find("CraneUnit").transform;

        craneStatus = -1;
        craneType = 5;
        host.manualCode = 7;

        // 様々なコンポーネントの取得
        //host = transform.root.Find("CP").GetComponent<MachineHost>();
        canvas = transform.Find("Canvas").gameObject;
        creditSystem = transform.Find("CreditSystem").GetComponent<CreditSystemV3>();
        //sp = transform.Find("SE").GetComponent<SEPlayer>();
        getPoint = transform.Find("Floor").Find("GetPoint").GetComponent<GetPointV3>();
        lifter = temp.Find("CraneBox").Find("Tube").Find("TubePoint").GetComponent<ArmUnitLifterV3>();
        armController = temp.Find("ArmUnit").GetComponent<TwinArmController>();
        support = temp.Find("ArmUnit").Find("Main").GetComponent<ArmControllerSupportV3>();
        craneBox = temp.Find("CraneBox").GetComponent<CraneBoxV3>();

        creditSystem.SetSEPlayer(sp);
        getPoint.SetManager(this);
        creditSystem.SetSEPlayer(sp);
        support.SetManager(this);
        support.SetLifter(lifter);
        lifter.Up(true);

        //// pos + 0.01
        //// 元:-0.31f 仮:-0.235f
        //if (!player2)
        //{
        //    startPoint = new Vector2(-0.61f + startPoint.x, -0.235f + startPoint.y);
        //    homePoint = new Vector2(-0.61f + homePoint.x, -0.235f + homePoint.y);
        //    if (boxRestrictions[0] < 100) xLimit.localPosition = new Vector3(-0.5f + 0.004525f * boxRestrictions[0], xLimit.localPosition.y, xLimit.localPosition.z);

        //    // 移動範囲制限
        //    craneBox.SetLimits(-0.61f + 0.004525f * boxRestrictions[0], -0.61f, -0.19f + 0.004525f * boxRestrictions[1], -0.235f);
        //}
        //else
        //{
        //    startPoint = new Vector2(0.61f - startPoint.x, -0.235f + startPoint.y);
        //    homePoint = new Vector2(0.61f - homePoint.x, -0.235f + homePoint.y);
        //    if (boxRestrictions[0] < 100) xLimit.localPosition = new Vector3(0.5f - 0.004525f * boxRestrictions[0], xLimit.localPosition.y, xLimit.localPosition.z);

        //    // 移動範囲制限
        //    craneBox.SetLimits(0.61f, 0.61f - 0.004525f * boxRestrictions[0], -0.19f + 0.004525f * boxRestrictions[1], -0.235f);
        //}
        //if (boxRestrictions[1] < 100) zLimit.localPosition = new Vector3(zLimit.localPosition.x, zLimit.localPosition.y, -0.19f + 0.00605f * boxRestrictions[1]);
        //if (downRestriction < 100) downLimit.localPosition = new Vector3(downLimit.localPosition.x, 1.4f - 0.005975f * downRestriction, downLimit.localPosition.z);
        //if (yHomePosition > 0 && yHomePosition <= 100)
        //{
        //    yHomePosition = -0.206f - 0.604f * (yHomePosition / 100.0f);
        //}
        //craneBox.GoPosition(startPoint);

        if (config != null)
        {
            StartCoroutine(DelayCoroutine(1000, () => { Setup(config); }));
        }
    }

    public void Setup(Type5mManagerConfig manager)
    {
        this.config = config;

        Transform temp = transform.Find("CraneUnit").transform;

        if (isHibernate)
        {
            creditSystem.SetHibernate();
        }

        if (!isHibernate)
        {
            if (!transform.parent.Find("LCD").gameObject.activeSelf)
                transform.parent.Find("LCD").gameObject.SetActive(true);

            // LCD内の価格表示
            preset[0].text = creditSystem.priceSets[0].ToString();
            preset[1].text = creditSystem.priceSets[1].ToString();
            preset[2].text = creditSystem.timesSets[0].ToString();
            preset[3].text = creditSystem.timesSets[1].ToString();

            if (!player2)
            {
                transform.parent.Find("LCD Component").Find("SegUnit3").gameObject.SetActive(true);
                transform.parent.Find("LCD Component").Find("SegUnit1").gameObject.SetActive(true);
            }
            else
            {
                transform.parent.Find("LCD Component").Find("SegUnit3 (1)").gameObject.SetActive(true);
                transform.parent.Find("LCD Component").Find("SegUnit1 (1)").gameObject.SetActive(true);
            }
        }

        if (!(isHibernate | creditSystem.priceSets[1] == 0 || creditSystem.timesSets[1] == 0 ||
(float)creditSystem.priceSets[0] / creditSystem.timesSets[0] < (float)creditSystem.priceSets[1] / creditSystem.timesSets[1]))
        // 正常なクレジットサービスが可能なとき
        {
            if (!player2)
                transform.parent.Find("LCD Component").Find("SegUnit2").gameObject.SetActive(true);
            else
                transform.parent.Find("LCD Component").Find("SegUnit2 (1)").gameObject.SetActive(true);
        }

        if (!config.downStop)
        {
            transform.Find("Canvas").Find("ControlGroup").Find("Button 3").gameObject.SetActive(false);
            transform.Find("Floor").Find("Button3").gameObject.SetActive(false);
        }

        // アームの設定
        for (int i = 0; i < 2; i++)
        {
            string a = "Arm" + (i + 1).ToString();
            GameObject arm;
            switch (config.armSize[i])
            {
                case 0:
                case 1:
                    a += "S";
                    break;
                case 2:
                    a += "M";
                    break;
                case 3:
                    a += "L";
                    break;
            }
            arm = temp.Find("ArmUnit").Find(a).gameObject;
            nail[i] = arm.transform.Find("Nail").GetComponent<ArmNailV3>();
            if (config.armSize[i] != 0) arm.SetActive(true);
            armController.SetArm(i, config.armSize[i]);
        }

        for (int i = 0; i < 2; i++)
        {
            nail[i].SetManager(this);
            nail[i].SetLifter(lifter);
        }

        if (soundType == 0 || soundType == 1 || soundType == 2) creditSystem.SetSoundNum(0);
        else creditSystem.SetSoundNum(8);

        switch (soundType)
        {
            case 0:
            case 1:
            case 2:
                getSoundNum = 7;
                break;
            case 3:
                getSoundNum = 15;
                break;
        }

        support.pushTime = config.pushTime; // 押し込みパワーの調整
        armController.SetLimit(config.armApertures);

        // アーム移動速度設定
        // 開始位置への移動前に設定すること
        this.SetArmMoveSpeed(config.armMoveSpeed);
        this.SetArmLiftSpeed(config.armUpSpeed, config.armDownSpeed);

        // 初期位置,開放位置の補正
        config.startPoint = GetCorrectedHomePosition(config.startPoint, config.armSize);
        config.homePoint = GetCorrectedHomePosition(config.homePoint, config.armSize);
        config.boxRestrictions = GetCorrectedBoxRestrictions(config.boxRestrictions);
        SetBoxRestriction(config.boxRestrictions);
        SetDownRestriction(config.downRestriction);

        StartCoroutine(Setup());
    }

    private IEnumerator Setup()
    {
        // ロープ巻取り確認
        if (!lifter.CheckPos(1))
        {
            lifter.Up(true);
            while (!lifter.CheckPos(1))
            {
                yield return null;
            }
        }

        // アームユニット位置確認
        if (!player2)
        {
            craneBox.Left(true);
            craneBox.Forward(true);
            while (!craneBox.CheckPos(1))
            {
                yield return null;
            }
        }
        else if (player2)
        {
            craneBox.Right(true);
            craneBox.Forward(true);
            while (!craneBox.CheckPos(3))
            {
                yield return null;
            }
        }

        // 開始位置まで移動
        Vector3 startPos = CalcGoPosition(config.startPoint);
        craneBox.GoPosition(new Vector2(startPos.x, startPos.z));
        
        while (!craneBox.CheckPos(9))
        {
            yield return null;
        }

        lifter.GoPosition(startPos.y);

        while (!lifter.CheckPos(3))
        {
            yield return null;
        }

        craneBox.cbs.useModule = true;
        creditSystem.Setup();

        craneStatus = 0;
    }

    IEnumerator Init()
    {
        // TODO: V3向けに作り直し

        Debug.Log("Starting...");
        yield return new WaitForSeconds(3);

        // TODO: イニシャライズ実装(3パターン)
        // 原点に移動
        craneBox.GoPosition(config.startPoint);

        // アーム開閉
        armController.Open();
        yield return new WaitForSeconds(1);
        armController.Close(100f);
        yield return new WaitForSeconds(1);

        // 中央に移動
        // TODO: 中央到達チェック未実装
        if (!player2) {
            craneBox.Right(true);
        } else {
            craneBox.Left(true);
        }
        craneBox.Back(true);

        // 奥に移動

        while (true)
        {
            if (craneBox.CheckPos(!player2 ? 4 : 2)) break;
            yield return null;
        }

        // 下降
        if (!player2) {
            craneBox.Right(false);
        } else {
            craneBox.Left(false);
        }
        craneBox.Back(false);
        lifter.Down(true);
        while (true)
        {
            if (lifter.CheckPos(2)) break;
            yield return null;
        }
        yield return new WaitForSeconds(1);

        // 上昇
        lifter.Up(true);
        while (true)
        {
            if (lifter.CheckPos(1)) break;
            yield return null;
        }
        yield return new WaitForSeconds(1);

        // 原点に移動
        // TODO: 実装
        if (!player2) {
            craneBox.Left(true);
        } else {
            craneBox.Right(true);
        }
        craneBox.Forward(true);

        // ホームポジションに移動
        while (true)
        {
            if (craneBox.CheckPos(!player2 ? 1 : 3)) break;
            yield return null;
        }
        if (!player2) {
            craneBox.Left(false);
        } else {
            craneBox.Right(false);
        }
        craneBox.Forward(false);

        StartCoroutine(Setup());
    }

    void Update()
    {
        if (useUI && host.playable && !canvas.activeSelf) canvas.SetActive(true);
        else if (!host.playable && canvas.activeSelf) canvas.SetActive(false);
        if (!player2 && (Input.GetKeyDown(KeyCode.Keypad0) || Input.GetKeyDown(KeyCode.Alpha0))) InsertCoin();
        else if (player2 && (Input.GetKeyDown(KeyCode.KeypadPeriod) || Input.GetKeyDown(KeyCode.Minus))) InsertCoin();

        // キー操作
        if (craneStatus > 0 && craneStatus <= 6)
        {
            DetectKey(craneStatus);
        }

        if (craneStatus == 0)
        {
        }
        else if (craneStatus == 1)
        {
            // コイン投入
        }
        else if (craneStatus == 2)
        {
            // 横移動中
            // 移動制限に達したら強制的に終了
            if (!player2 && craneBox.CheckPos(7))
            {
                buttonPushed = false;
                craneStatus = 3;
            }
            if (player2 && craneBox.CheckPos(5))
            {
                buttonPushed = false;
                craneStatus = 3;
            }

            // 横移動効果音ループ再生;
        }
        else if (craneStatus == 3)
        {
            // 横移動終了

        }
        else if (craneStatus == 4)
        {
            // 奥移動中
            if (craneBox.CheckPos(8))
            {
                buttonPushed = false;
                craneStatus = 5;
            }
        }
        else if (craneStatus == 6)
        {
            // アーム下降が終了した
            if (lifter.CheckPos(2))
            {
                craneStatus = 7;
            }
        }
        else if (craneStatus == 8)
        {
            if (lifter.CheckPos(1))
            {
                craneStatus = 9;
            }
        }
        else if (craneStatus == 10)
        {
            if (craneBox.CheckPos(config.prizezoneType))
            {
                craneStatus = 11;
            }
        }
        else if (craneStatus == 13)
        {
            if ((craneBox.CheckPos(1) && !player2) || (craneBox.CheckPos(3) && player2))
            {
                craneStatus = 14;
            }
        }
    }

    void FixedUpdate()
    {
        if (craneStatus != 0)
        {
            if (craneStatus == 8)
            {
                if (probability)
                {
                    if (armLPower > config.armLPowerConfigSuccess[1]) armLPower -= 0.15f;
                    if (armRPower > config.armRPowerConfigSuccess[1]) armRPower -= 0.15f;
                }
                else
                {
                    if (armLPower > config.armLPowerConfig[1]) armLPower -= 0.15f;
                    if (armRPower > config.armRPowerConfig[1]) armRPower -= 0.15f;
                }
                armController.SetMotorPower(armLPower, 0);
                armController.SetMotorPower(armRPower, 1);
            }
            else if (craneStatus == 10 || craneStatus == 15)
            {
                if (craneStatus == 10)
                {
                    if (probability)
                    {
                        if (armLPower > config.armLPowerConfigSuccess[2]) armLPower -= 0.15f;
                        if (armRPower > config.armRPowerConfigSuccess[2]) armRPower -= 0.15f;
                    }
                    else
                    {
                        if (armLPower > config.armLPowerConfig[2]) armLPower -= 0.15f;
                        if (armRPower > config.armRPowerConfig[2]) armRPower -= 0.15f;
                    }
                    armController.SetMotorPower(armLPower, 0);
                    armController.SetMotorPower(armRPower, 1);
                }
            }
        }
    }

    public override void GetPrize()
    {
        if (net == null) // ネットワークに参加していないとき
            for (int i = 0; i < 3; i++) animator[i].SetTrigger("GetPrize");
        else
            net.CelebrateAll();
        base.GetPrize();
    }

    protected override void DetectKey(int num)
    {
        if (host.playable)
        {
            switch (num)
            {
                case 1:
                    if ((Input.GetKeyDown(KeyCode.Keypad1) || Input.GetKeyDown(KeyCode.Alpha1)) && !buttonPushed && !player2)
                    {
                        ButtonDown(1);
                    }
                    if ((Input.GetKeyDown(KeyCode.Keypad7) || Input.GetKeyDown(KeyCode.Alpha7)) && !buttonPushed && player2)
                    {
                        ButtonDown(4);
                    }
                    break;
                //投入を無効化
                case 2:
                    if ((Input.GetKeyUp(KeyCode.Keypad1) || Input.GetKeyUp(KeyCode.Alpha1)) && buttonPushed && !player2)
                    {
                        ButtonUp(1);
                    }
                    if ((Input.GetKeyUp(KeyCode.Keypad7) || Input.GetKeyUp(KeyCode.Alpha7)) && buttonPushed && player2)
                    {
                        ButtonUp(4);
                    }
                    break;
                case 3:
                    if ((Input.GetKeyDown(KeyCode.Keypad2) || Input.GetKeyDown(KeyCode.Alpha2)) && !buttonPushed && !player2)
                    {
                        ButtonDown(2);
                    }
                    if ((Input.GetKeyDown(KeyCode.Keypad8) || Input.GetKeyDown(KeyCode.Alpha8)) && !buttonPushed && player2)
                    {
                        ButtonDown(2);
                    }
                    break;
                case 4:
                    if ((Input.GetKeyUp(KeyCode.Keypad2) || Input.GetKeyUp(KeyCode.Alpha2)) && buttonPushed && !player2)
                    {
                        ButtonUp(2);
                    }
                    if ((Input.GetKeyUp(KeyCode.Keypad8) || Input.GetKeyUp(KeyCode.Alpha8)) && buttonPushed && player2)
                    {
                        ButtonUp(2);
                    }
                    break;
                case 6:
                    if ((Input.GetKeyDown(KeyCode.Keypad3) || Input.GetKeyDown(KeyCode.Alpha3)) && !player2 && config.downStop)
                    {
                        ButtonDown(3);
                    }
                    if ((Input.GetKeyDown(KeyCode.Keypad9) || Input.GetKeyDown(KeyCode.Alpha9)) && player2 && config.downStop)
                    {
                        ButtonDown(3);
                    }
                    break;
            }
        }
    }

    public override void ButtonDown(int num)
    {
        switch (num)
        {
            case 1:
                if (craneStatus == 1 && !buttonPushed)
                {
                    buttonPushed = true;
                    craneStatus = 2;
                }
                break;
            case 2:
                if ((craneStatus == 3 && !buttonPushed) || (craneStatus == 4 && buttonPushed))
                {
                    buttonPushed = true;
                    craneStatus = 4;
                }
                break;
            case 3:
                if (craneStatus == 6)
                {
                    lifter.Down(false);
                    craneStatus = 7;
                }
                break;
            case 4: // player2 case 1:
                if (craneStatus == 1 && !buttonPushed)
                {
                    buttonPushed = true;
                    craneStatus = 2;
                }
                break;
        }
    }

    public override void ButtonUp(int num)
    {
        switch (num)
        {
            case 1:
                if (craneStatus == 2 && buttonPushed)
                {
                    craneStatus = 3;
                    buttonPushed = false;
                }
                break;
            case 2:
                if (craneStatus == 4 && buttonPushed)
                {
                    craneStatus = 5;
                    buttonPushed = false;
                }
                break;
            case 4: // player2 case 1:
                if (craneStatus == 2 && buttonPushed)
                {
                    craneStatus = 3;
                    buttonPushed = false;
                }
                break;
        }
    }

    public override void InsertCoin()
    {
        if (!isHibernate && host.playable && craneStatus >= 0)
        {
            int credit = creditSystem.Pay(100);
            if (credit < 100) credit3d.text = credit.ToString();
            else credit3d.text = "99.";
            if (credit > 0 && craneStatus == 0) craneStatus = 1;
        }
    }

    public override void InsertCoinAuto()
    {
        if (!isHibernate && craneStatus >= 0)
        {
            int credit = creditSystem.Pay(100);
            if (credit < 100) credit3d.text = credit.ToString();
            else credit3d.text = "99.";
            if (credit > 0 && craneStatus == 0) craneStatus = 1;
        }
    }

    protected override void FirstStatusEvent(int status)
    {
        switch (status)
        {
            case 2:
                // 右方向移動中
                // 確率カウント
                creditSystem.ResetPay();
                creditSystem.NewPlay();

                // クレジットの消費
                int credit = creditSystem.DecrementCredit();
                credit3d.text = credit < 100 ? credit.ToString() : "99.";

                // 確率抽選
                probability = creditSystem.ProbabilityCheck();
                Debug.Log("Probability:" + probability);

                // 移動
                if (!player2)
                {
                    craneBox.Right(true);
                }
                else
                {
                    craneBox.Left(true);
                }

                // 効果音を再生する
                switch (soundType)
                {
                    case 0:
                    case 1:
                    case 2:
                        sp.Play(1);
                        break;
                    case 3:
                        sp.Play(9);
                        break;
                }
                break;

            case 3:
                // 右方向移動終了
                if (!player2)
                {
                    craneBox.Right(false);
                }
                else
                {
                    craneBox.Left(false);
                }

                // 効果音を停止する
                switch (soundType)
                {
                    case 0:
                    case 1:
                    case 2:
                        sp.Stop(1);
                        break;
                    case 3:
                        sp.Stop(9);
                        break;
                }
                break;

            case 4:
                // 奥方向移動中
                craneBox.Back(true);

                // TODO: 移動終了からアーム開きまでのウェイト
                // UFO9 -> 300ms

                // 効果音を再生する
                switch (soundType)
                {
                    case 0:
                    case 1:
                    case 2:
                        sp.Play(2);
                        break;

                    case 3:
                        sp.Play(10);
                        break;
                }
                break;

            case 5:
                // 奥移動効果音を停止
                sp.Stop(1);

                // 奥方向移動終了
                craneBox.Back(false);

                int waitTime = 1700;
                // ウェイトの設定
                switch (soundType)
                {
                    case 0:
                    case 1:
                        // アーム開度によるウェイトのズレは無いことを確認済み
                        waitTime = 1230;
                        break;
                    case 2:
                        waitTime = 860;
                        break;
                    case 3:
                        break;
                }

                // アーム開度を設定
                armController.SetLimit(config.armApertures);

                // アームを開く
                //armController.Open();
                switch (soundType)
                {
                    case 0:
                    case 1:
                        armController.Open(-70f);
                        sp.Stop(2);
                        sp.Play(3, 1);
                        break;
                    case 2:
                        armController.Open(-65f);
                        sp.Stop(2);
                        sp.Play(3, 1);
                        break;
                    case 3:
                        armController.Open(-45f);
                        sp.Stop(10);
                        sp.Play(11, 1);
                        break;
                }

                // 効果音を再生する
                switch (soundType)
                {
                    case 0:
                    case 1:
                    case 2:
                        sp.Stop(2);
                        sp.Play(3, 1);
                        break;
                    case 3:
                        sp.Stop(10);
                        sp.Play(11, 1);
                        break;
                }

                // 下降開始してstatusを進める
                StartCoroutine(DelayCoroutine(waitTime, () =>
                {
                    if (craneStatus == 5) craneStatus = 6;
                }));
                break;

            case 6:
                // 下降中
                // 効果音を再生する
                switch (soundType)
                {
                    case 0:
                    case 1:
                    case 2:
                        sp.Play(4);
                        break;
                    case 3:
                        sp.Play(12);
                        break;
                }
                // アーム下降を開始する
                lifter.Down(true);
                break;

            case 7:
                // 下降停止
                // 下降の効果音を停止する
                switch (soundType)
                {
                    case 0:
                    case 1:
                    case 2:
                        sp.Stop(4);
                        break;
                    case 3:
                        sp.Stop(12);
                        break;
                }

                // ウェイトの設定
                int downWaitTime = 1000;
                int closeWaitTime = 3000;
                switch (soundType)
                {
                    case 0:
                    case 1:
                        downWaitTime = 500;
                        closeWaitTime = 2750;
                        break;
                }

                StartCoroutine(DelayCoroutine(downWaitTime, () =>
                {
                    // 掴む効果音を再生する
                    switch (soundType)
                    {
                        case 0:
                        case 1:
                        case 2:
                            sp.Play(5, 1);
                            break;
                        case 3:
                            sp.Play(13, 1);
                            break;
                    }

                    // アームを閉じる
                    switch (soundType)
                    {
                        case 0:
                        case 1:
                            sp.Play(5, 1);
                            armController.Close(30f, 35f);
                            break;
                        case 2:
                            sp.Play(5, 1);
                            armController.Close(30f, 32.5f);
                            break;
                        case 3:
                            sp.Play(13, 1);
                            armController.Close(30f, 22f);
                            break;
                    }

                    StartCoroutine(DelayCoroutine(closeWaitTime, () =>
                    {
                        if (!config.useMotor)
                        {
                            armController.ToggleMotor(false);
                            armController.SetArmPower(config.armLPowerConfigSuccess[0], config.armSize[0], 0);
                            armController.SetArmPower(config.armRPowerConfigSuccess[0], config.armSize[1], 1);
                        }

                        // 閉じ速度に影響しないよう、効果音が再生された後でパワーを入れる
                        if (probability)
                        {
                            if (config.armLPowerConfigSuccess[0] >= 30) armLPower = config.armLPowerConfigSuccess[0];
                            else armLPower = 30f;
                            if (config.armRPowerConfigSuccess[0] >= 30) armRPower = config.armRPowerConfigSuccess[0];
                            else armRPower = 30f;
                        }
                        else
                        {
                            if (config.armLPowerConfig[0] >= 30) armLPower = config.armLPowerConfig[0];
                            else armLPower = 30f;
                            if (config.armRPowerConfig[0] >= 30) armRPower = config.armRPowerConfig[0];
                            else armRPower = 30f;
                        }
                        armController.SetMotorPower(armLPower, 0);
                        armController.SetMotorPower(armRPower, 1);

                        craneStatus = 8;
                    }));
                }));
                break;

            case 8:
                // アーム上昇開始
                // 効果音を再生する
                //armController.ToggleMotor(false);
                switch (soundType)
                {
                    case 0:
                    case 1:
                    case 2:
                        sp.Play(4);
                        break;
                    case 3:
                        sp.Play(14);
                        break;
                }

                // アームを上昇する
                lifter.Up(true);
                break;

            case 9:
                // アーム上昇停止
                // 効果音を停止する
                switch (soundType)
                {
                    case 0:
                    case 1:
                    case 2:
                        sp.Stop(4);
                        break;
                    case 3:
                        sp.Stop(14);
                        break;
                }
                StartCoroutine(DelayCoroutine(200, () =>
                {
                    // アームパワーを決定する
                    if (probability)
                    {
                        armLPower = config.armLPowerConfigSuccess[1];
                        armRPower = config.armLPowerConfigSuccess[1];
                    }
                    else
                    {
                        armLPower = config.armLPowerConfig[1];
                        armRPower = config.armRPowerConfig[1];
                    }

                    // アームパワーを設定する
                    armController.SetMotorPower(armLPower, 0);
                    armController.SetMotorPower(armRPower, 1);

                    craneStatus = 10;
                }));
                break;

            case 10:
                // アーム獲得口ポジションへ移動
                // 任意座標への移動はここで設定
                if (config.prizezoneType == 9)
                {
                    Vector3 homePos = CalcGoPosition(config.homePoint);
                    craneBox.GoPosition(new Vector2(homePos.x, homePos.z));
                }
                else
                {
                    switch (config.prizezoneType) // 1:左手前，2：左奥，3：右手前，4：右奥，5：左，6：手前，7：右，8：奥，9：特定座標
                    {
                        case 1:
                            craneBox.Left(true);
                            craneBox.Forward(true);
                            break;
                        case 2:
                            craneBox.Left(true);
                            craneBox.Back(true);
                            break;
                        case 3:
                            craneBox.Right(true);
                            craneBox.Forward(true);
                            break;
                        case 4:
                            craneBox.Right(true);
                            craneBox.Back(true);
                            break;
                        case 5:
                            craneBox.Left(true);
                            break;
                        case 6:
                            craneBox.Forward(true);
                            break;
                        case 7:
                            craneBox.Right(true);
                            break;
                        case 8:
                            craneBox.Back(true);
                            break;
                    }
                }

                // 効果音を再生する
                switch (soundType)
                {
                    case 0:
                    case 1:
                    case 2:
                        sp.Play(6);
                        break;
                    case 3:
                        sp.Play(9);
                        break;
                }
                break;

            case 11:
                // アーム開放
                // 移動を停止させる
                craneBox.Left(false);
                craneBox.Right(false);
                craneBox.Back(false);
                craneBox.Forward(false);

                // アーム開度の設定
                // 開放時は一時的に開度100%に変更
                armController.SetLimit(100f);

                // 効果音の停止,開放待ち
                // UFO7では2秒,UFO8では3秒,UFO9では1秒待ってから開く
                var openWaitTime = 1000;
                switch (soundType)
                {
                    case 2:
                        sp.Stop(6);
                        openWaitTime = 3000;
                        break;
                    case 3:
                        sp.Stop(9);
                        openWaitTime = 2000;
                        break;
                    default:
                        sp.Stop(6);
                        break;
                }

                StartCoroutine(DelayCoroutine(openWaitTime, () =>
                {
                    // 効果音を再生する
                    switch (soundType)
                    {
                        case 0:
                        case 1:
                        case 2:
                            sp.Play(3, 1);
                            break;
                        case 3:
                            sp.Play(11, 1);
                            break;
                    }
                    // アームを開く
                    //armController.Open();
                    switch (soundType)
                    {
                        case 0:
                        case 1:
                            sp.Stop(6);
                            sp.Play(3, 1);
                            armController.Open(-70);
                            break;
                        case 2:
                            sp.Stop(6);
                            sp.Play(3, 1);
                            armController.Open(-65);
                            break;
                        case 3:
                            sp.Stop(9);
                            sp.Play(11, 1);
                            armController.Open(-45f);
                            break;
                    }

                    StartCoroutine(DelayCoroutine(2500, () =>
                    {
                        craneStatus = 12;
                    }));
                }));
                break;

            case 12:
                // アーム閉じる
                // 効果音を再生する
                switch (soundType)
                {
                    case 0:
                    case 1:
                    case 2:
                        sp.Play(5, 1);
                        break;
                    case 3:
                        sp.Play(13, 1);
                        break;
                }
                // アームを閉じる
                //armController.Close(100f);
                switch (soundType)
                {
                    case 0:
                    case 1:
                        sp.Play(5, 1);
                        armController.Close(100f, 35f);
                        break;
                    case 2:
                        sp.Play(5, 1);
                        armController.Close(100f, 32.5f);
                        break;
                    case 3:
                        sp.Play(13, 1);
                        armController.Close(100f, 22f);
                        break;
                }

                // 1秒(->2.45秒)待機した後に遷移
                StartCoroutine(DelayCoroutine(2450, () =>
                {
                    craneStatus = 13;
                }));
                break;

            case 13:
                // アーム初期位置へ移動
                // TODO: ここのGoPositionだけモーター音が停止しない
                // TODO: 必ずしも0,0への移動ではない(9で確認)
                //craneBox.GoPosition(homePoint);
                if (!player2)
                {
                    craneBox.Left(true);
                }
                else
                {
                    craneBox.Right(true);
                }
                craneBox.Forward(true);

                // 効果音を再生する
                switch (soundType)
                {
                    case 0:
                    case 1:
                    case 2:
                        sp.Play(6);
                        break;
                }
                break;

            case 14:
                // アーム初期位置へ移動終了
                // 移動停止
                craneBox.Left(false);
                craneBox.Right(false);
                craneBox.Back(false);
                craneBox.Forward(false);

                // 効果音を停止する
                switch (soundType)
                {
                    case 0:
                    case 1:
                    case 2:
                        sp.Stop(6);
                        break;
                }

                // 1秒待つ
                StartCoroutine(DelayCoroutine(1000, () =>
                {
                    StartCoroutine(EndInit());
                }));
                break;
        }
    }

    protected override void LastStatusEvent(int status)
    {

    }

    private IEnumerator EndInit()
    {
        // 開始位置の絶対座標を取得する
        Vector3 startPos = CalcGoPosition(config.startPoint);

        // 効果音を再生する
        switch (soundType)
        {
            case 0:
            case 1:
            case 2:
                sp.Play(6);
                break;
        }

        // ホームポジションへ移動
        // 移動
        craneBox.GoPosition(new Vector2(startPos.x, startPos.z));

        while (!craneBox.CheckPos(9))
        {
            yield return null;
        }

        // 移動音を停止
        switch (soundType)
        {
            case 0:
            case 1:
            case 2:
                sp.Stop(6);
                break;
        }

        // 移動を停止させる
        craneBox.Left(false);
        craneBox.Right(false);
        craneBox.Back(false);
        craneBox.Forward(false);

        // TODO: Yホムポジが0ならここで0,1に戻す判定

        // 1秒待つ
        yield return new WaitForSeconds(1.0f);

        // Y軸ホームポジションへ移動
        // 移動
        lifter.GoPosition(startPos.y);

        // 効果音を再生する
        switch (soundType)
        {
            case 0:
            case 1:
            case 2:
                sp.Play(4);
                break;
        }

        while (!lifter.CheckPos(3))
        {
            yield return null;
        }

        // Y軸ホームポジションへ移動終了
        // 効果音を停止する
        switch (soundType)
        {
            case 0:
            case 1:
            case 2:
                sp.Stop(4);
                break;
        }

        // TODO: 待機時間を実機で調べる
        // 残りクレジットがあればstatusを1に、なければ0に
        craneStatus = creditSystem.GetCreditCount() > 0 ? 1 : 0;
    }

    /// <summary>
    /// アームの移動速度を設定する
    /// </summary>
    /// <param name="_moveSpeed">移動速度</param>
    private void SetArmMoveSpeed(int _moveSpeed)
    {
        // 移動速度配列
        float[] speedDelta = new float[] { 0.002f, 0.0025f, 0.003f, 0.0035f, 0.004f };

        // 設定する移動速度
        float setSpeed;
        switch (_moveSpeed)
        {
            case 1:
            case 2:
            case 3:
            case 4:
            case 5:
                setSpeed = speedDelta[_moveSpeed - 1];
                break;
            default:
                setSpeed = speedDelta[2];
                break;
        }

        // 移動速度を設定する
        craneBox.SetMoveSpeeds(setSpeed, setSpeed);
    }

    /// <summary>
    /// アームの昇降速度を設定する
    /// </summary>
    /// <param name="_upSpeed">アームの上昇速度</param>
    /// <param name="_downSpeed">アームの降下速度</param>
    private void SetArmLiftSpeed(int _upSpeed, int _downSpeed)
    {
        // 昇降速度配列
        float[] speedDelta = new float[] { 0.002f, 0.0025f, 0.003f, 0.0035f, 0.004f };

        // 設定する上昇速度
        float setUpSpeed;
        switch (_upSpeed)
        {
            case 1:
            case 2:
            case 3:
            case 4:
            case 5:
                setUpSpeed = speedDelta[_upSpeed - 1];
                break;
            default:
                setUpSpeed = speedDelta[2];
                break;
        }

        // 設定する降下速度
        float setDownSpeed;
        switch (_downSpeed)
        {
            case 1:
            case 2:
            case 3:
            case 4:
            case 5:
                setDownSpeed = speedDelta[_downSpeed - 1];
                break;
            default:
                setDownSpeed = speedDelta[2];
                break;
        }

        // 昇降速度を設定する
        lifter.SetMoveSpeeds(setUpSpeed, setDownSpeed);
    }

    /// <summary>
    /// アームサイズを考慮した開始位置座標を計算して返す
    /// </summary>
    /// <remarks>
    /// 指定した座標がアームサイズを考慮した座標よりも外側だった場合のみ、補正した値を返します。
    /// 現状アームユニットの向きが正面前提なので、90度回転を行う場合は使わないことを推奨します。
    /// </remarks>
    /// <param name="_position">補正なしの座標</param>
    /// <param name="_armSize">アームサイズ</param>
    /// <returns>座標</returns>
    private Vector3 GetCorrectedHomePosition(Vector3 _position, int[] _armSize)
    {
        // アームサイズごとの補正値
        float[] delta = new float[] { 0, 3, 11, 20 };

        // TODO: アームユニットの角度を考慮する
        // 基準アームサイズ候補
        // アームサイズの大きい方を基準とする
        int arm = _armSize[0] > _armSize[1] ? _armSize[1] : _armSize[0];

        // 候補座標(%)
        float draftXPosition = 0;
        float draftZPosition = 0;

        draftXPosition = _position.x < delta[arm] ? delta[arm] : _position.x;

        return new Vector3(draftXPosition, _position.y, draftZPosition);
    }

    /// <summary>
    /// アームサイズを考慮した移動制限を設定する
    /// </summary>
    /// <param name="_restrictions">移動制限</param>
    /// <returns>アームサイズを考慮した移動制限</returns>
    private float[] GetCorrectedBoxRestrictions(float[] _restrictions)
    {
        float[] delta = new float[] { 0, 95, 87, 78 };

        // 基準アームサイズ候補
        int[] _armSize = config.armSize;
        int arm = _armSize[0] > _armSize[1] ? _armSize[1] : _armSize[0];

        // 候補座標(%)
        float draftXRestriction = 0;
        float draftZRestriction = 0;

        draftXRestriction = config.armUnitAngle >= 45 ? 99 : 
            _restrictions[0] > delta[arm] ? delta[arm] : _restrictions[0];
        draftZRestriction = config.armUnitAngle >= 45 ?
            _restrictions[1] > delta[arm] ? delta[arm] : _restrictions[1]
            : 97;

        return new float[] { draftXRestriction, draftZRestriction };
    }

    /// <summary>
    /// 移動制限を設定する
    /// </summary>
    /// <param name="_restrictions">移動制限</param>
    private void SetBoxRestriction(float[] _restrictions)
    {
        float left = 0f;
        float right = 0f;
        float front = FRONT_LIMIT;
        float back = BACK_LIMIT * (_restrictions[1] / 100.0f);

        // 外側リミット座標から内側リミット座標までの距離を求める
        float range = OUTER_LIMIT - INNER_LIMIT;

        if (!player2)
        {
            left = OUTER_LIMIT * -1.0f;
            right = -OUTER_LIMIT + range * (_restrictions[0] / 100.0f);
        }
        else
        {
            left = OUTER_LIMIT - range * (_restrictions[0] / 100.0f);
            right = OUTER_LIMIT;
        }
        craneBox.SetLimits(right, left, back, front);
    }

    /// <summary>
    /// 下降制限を設定する
    /// </summary>
    private void SetDownRestriction(float _downRestriction)
    {
        float range = Math.Abs(DOWN_LIMIT - UP_LIMIT);

        lifter.SetLimits(UP_LIMIT, UP_LIMIT - range * (_downRestriction / 100.0f));
    }

    private Vector3 CalcGoPosition(Vector3 pos)
    {
        int armSize = 0;
        float x = 0;
        float y = 0;
        float z = 0;

        y = lifter.upLimit - (Mathf.Abs(lifter.upLimit - lifter.downLimit) / 100 * pos.y);
        z = FRONT_LIMIT + 0.59f / 100 * pos.z;

        if (config.armSize[0] > armSize) armSize = config.armSize[0];
        if (config.armSize[1] > armSize) armSize = config.armSize[1];

        switch (armSize)
        {
            case 0:
            case 1:
                // -0.64 ~ -0.19
                if (!player2)
                {
                    x = (0.64f - (0.64f - 0.19f) / 100 * pos.x) * -1;
                }
                else
                {
                    x = 0.64f - (0.64f - 0.19f) / 100 * pos.x;
                }
                break;
            case 2:
                // 暫定
                if (!player2)
                {
                    x = (0.64f - (0.64f - 0.19f) / 100 * pos.x) * -1;
                }
                else
                {
                    x = 0.64f - (0.64f - 0.19f) / 100 * pos.x;
                }
                break;
            case 3:
                // 暫定
                if (!player2)
                {
                    x = (0.64f - (0.64f - 0.19f) / 100 * pos.x) * -1;
                }
                else
                {
                    x = 0.64f - (0.64f - 0.19f) / 100 * pos.x;
                }
                break;
        }

        return new Vector3(x, y, z);
    }
}
